Bug 1266999 - Review Request: tcmu-runner - a daemon that supports LIO userspace backends
Review Request: tcmu-runner - a daemon that supports LIO userspace backends
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Chris Leech
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-09-28 14:59 EDT by Andy Grover
Modified: 2015-10-19 12:43 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-10-19 12:43:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
cleech: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Andy Grover 2015-09-28 14:59:56 EDT
Spec URL: https://fedorapeople.org/~grover/new/tcmu-runner.spec
SRPM URL: https://fedorapeople.org/~grover/new/tcmu-runner-0.9.0-1.fc22.src.rpm
Description: 

A daemon that handles the complexity of the LIO kernel target's userspace
passthrough interface (TCMU). It presents a C plugin API for extension modules
that handle SCSI requests in ways not possible or suitable to be handled
by LIO's in-kernel backstores.

Fedora Account System Username: grover
Comment 1 Chris Leech 2015-10-09 17:01:33 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======
- If (and only if) the source package includes the text of the license(s)
  in its own file, then that file, containing the text of the license(s)
  for the package is included in %license.
  Note: License file LICENSE is marked as %doc instead of %license
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text

- D-Bus configuration files, systemd service files, and DSOs are installed as
  executable when they shouldn't be.

  /etc/dbus-1/system.d/tcmu-runner.conf
  /usr/lib/systemd/system/tcmu-runner.service
  /usr/lib64/tcmu-runner/handler_file.so
  /usr/lib64/tcmu-runner/handler_glfs.so
  /usr/share/dbus-1/system-services/org.kernel.TCMUService1.service

- %config file not marked noreplace (/etc/dbus-1/system.d/tcmu-runner.conf)

  Note, it looks like a toss-up on my system as to which of these D-Bus policy
  files are marked as %config(noreplace) or just as a regular file.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Apache (v2.0)", "Unknown or generated".
     1 files have unknown license. Detailed output of licensecheck in
     /home/cleech/review/1266999-tcmu-runner/licensecheck.txt
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/dbus-1/system-
     services, /usr/share/dbus-1, /etc/dbus-1, /usr/lib/systemd/system,
     /usr/lib/systemd, /etc/dbus-1/system.d
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[!]: %config files are marked noreplace or the reason is justified.
     Note: No (noreplace) in %config /etc/dbus-1/system.d/tcmu-runner.conf
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[?]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: tcmu-runner-0.9.0-1.fc24.x86_64.rpm
          tcmu-runner-0.9.0-1.fc24.src.rpm
tcmu-runner.x86_64: W: spelling-error Summary(en_US) userspace -> user space, user-space, users pace
tcmu-runner.x86_64: W: spelling-error Summary(en_US) backends -> back ends, back-ends, backhands
tcmu-runner.x86_64: W: spelling-error %description -l en_US userspace -> user space, user-space, users pace
tcmu-runner.x86_64: W: spelling-error %description -l en_US passthrough -> pass through, pass-through, roughcast
tcmu-runner.x86_64: W: spelling-error %description -l en_US backstores -> back stores, back-stores, backstrokes
tcmu-runner.x86_64: W: conffile-without-noreplace-flag /etc/dbus-1/system.d/tcmu-runner.conf
tcmu-runner.x86_64: E: script-without-shebang /usr/share/dbus-1/system-services/org.kernel.TCMUService1.service
tcmu-runner.x86_64: E: executable-marked-as-config-file /etc/dbus-1/system.d/tcmu-runner.conf
tcmu-runner.x86_64: E: script-without-shebang /etc/dbus-1/system.d/tcmu-runner.conf
tcmu-runner.x86_64: E: script-without-shebang /usr/lib/systemd/system/tcmu-runner.service
tcmu-runner.x86_64: W: no-manual-page-for-binary tcmu-runner
tcmu-runner.src: W: spelling-error Summary(en_US) userspace -> user space, user-space, users pace
tcmu-runner.src: W: spelling-error Summary(en_US) backends -> back ends, back-ends, backhands
tcmu-runner.src: W: spelling-error %description -l en_US userspace -> user space, user-space, users pace
tcmu-runner.src: W: spelling-error %description -l en_US passthrough -> pass through, pass-through, roughcast
tcmu-runner.src: W: spelling-error %description -l en_US backstores -> back stores, back-stores, backstrokes
2 packages and 0 specfiles checked; 4 errors, 12 warnings.




Rpmlint (debuginfo)
-------------------
Checking: tcmu-runner-debuginfo-0.9.0-1.fc24.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
tcmu-runner.x86_64: W: conffile-without-noreplace-flag /etc/dbus-1/system.d/tcmu-runner.conf
tcmu-runner.x86_64: E: executable-marked-as-config-file /etc/dbus-1/system.d/tcmu-runner.conf
tcmu-runner.x86_64: E: script-without-shebang /etc/dbus-1/system.d/tcmu-runner.conf
tcmu-runner.x86_64: E: script-without-shebang /usr/lib/systemd/system/tcmu-runner.service
tcmu-runner.x86_64: E: script-without-shebang /usr/share/dbus-1/system-services/org.kernel.TCMUService1.service
tcmu-runner.x86_64: W: no-manual-page-for-binary tcmu-runner
2 packages and 0 specfiles checked; 4 errors, 2 warnings.



Requires
--------
tcmu-runner (rpmlib, GLIBC filtered):
    config(tcmu-runner)
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_3.3.1)(64bit)
    libgfapi.so.0()(64bit)
    libgfapi.so.0(GFAPI_3.4.0)(64bit)
    libgfapi.so.0(GFAPI_3.5.0)(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libkmod.so.2()(64bit)
    libkmod.so.2(LIBKMOD_5)(64bit)
    libnl-3.so.200()(64bit)
    libnl-3.so.200(libnl_3)(64bit)
    libnl-genl-3.so.200()(64bit)
    libnl-genl-3.so.200(libnl_3)(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)
    targetcli



Provides
--------
tcmu-runner:
    config(tcmu-runner)
    tcmu-runner
    tcmu-runner(x86-64)



Unversioned so-files
--------------------
tcmu-runner: /usr/lib64/tcmu-runner/handler_file.so
tcmu-runner: /usr/lib64/tcmu-runner/handler_glfs.so

Source checksums
----------------
https://fedorahosted.org/released/tcmu-runner/tcmu-runner-0.9.0.tar.gz :
  CHECKSUM(SHA256) this package     : d8ab0cde1b7273355a43a4b39234da847575f855033d5b206cdfbe65979fa05e
  CHECKSUM(SHA256) upstream package : d8ab0cde1b7273355a43a4b39234da847575f855033d5b206cdfbe65979fa05e


Generated by fedora-review 0.5.3 (bcf15e3) last change: 2015-05-04
Command line :/usr/bin/fedora-review -b 1266999 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 2 Chris Leech 2015-10-09 17:02:58 EDT
%install section looks OK given the lack of an upstream install target, but should be replaced with a simple "make install DESTDIR=%{buildroot}" once upstream gets some cmake help :)
Comment 3 Andy Grover 2015-10-12 12:40:20 EDT
Thanks! Revised .spec addressing the three issues, and will work on a proper "make install" for a future upstream release.

Spec URL: https://fedorapeople.org/~grover/new/tcmu-runner.spec
SRPM URL: https://fedorapeople.org/~grover/new/tcmu-runner-0.9.0-2.fc22.src.rpm
Comment 4 Chris Leech 2015-10-12 14:00:49 EDT
Sorry, looks like I gave bad feedback about the executable mode of the plugin DSOs.  If they're not executable, they don't get processed for debuginfo.

I think this needs to go back to 755

-%{__install} -pm 644 *.so %{buildroot}%{_libdir}/tcmu-runner
+%{__install} -pm 755 *.so %{buildroot}%{_libdir}/tcmu-runner

and then everything looks good to me.
Comment 6 Chris Leech 2015-10-12 15:05:49 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Apache (v2.0)", "Unknown or generated".
     1 files have unknown license. Detailed output of licensecheck in
     /home/cleech/review/1266999-tcmu-runner/licensecheck.txt
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/dbus-1/system-
     services, /usr/share/dbus-1, /etc/dbus-1, /usr/lib/systemd/system,
     /usr/lib/systemd, /etc/dbus-1/system.d
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[?]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: tcmu-runner-0.9.0-3.fc24.x86_64.rpm
          tcmu-runner-0.9.0-3.fc24.src.rpm
tcmu-runner.x86_64: W: spelling-error Summary(en_US) userspace -> user space, user-space, users pace
tcmu-runner.x86_64: W: spelling-error Summary(en_US) backends -> back ends, back-ends, backhands
tcmu-runner.x86_64: W: spelling-error %description -l en_US userspace -> user space, user-space, users pace
tcmu-runner.x86_64: W: spelling-error %description -l en_US passthrough -> pass through, pass-through, roughcast
tcmu-runner.x86_64: W: spelling-error %description -l en_US backstores -> back stores, back-stores, backstrokes
tcmu-runner.x86_64: W: non-conffile-in-etc /etc/dbus-1/system.d/tcmu-runner.conf
tcmu-runner.x86_64: W: no-manual-page-for-binary tcmu-runner
tcmu-runner.src: W: spelling-error Summary(en_US) userspace -> user space, user-space, users pace
tcmu-runner.src: W: spelling-error Summary(en_US) backends -> back ends, back-ends, backhands
tcmu-runner.src: W: spelling-error %description -l en_US userspace -> user space, user-space, users pace
tcmu-runner.src: W: spelling-error %description -l en_US passthrough -> pass through, pass-through, roughcast
tcmu-runner.src: W: spelling-error %description -l en_US backstores -> back stores, back-stores, backstrokes
2 packages and 0 specfiles checked; 0 errors, 12 warnings.




Rpmlint (debuginfo)
-------------------
Checking: tcmu-runner-debuginfo-0.9.0-3.fc24.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
tcmu-runner.x86_64: W: non-conffile-in-etc /etc/dbus-1/system.d/tcmu-runner.conf
tcmu-runner.x86_64: W: no-manual-page-for-binary tcmu-runner
2 packages and 0 specfiles checked; 0 errors, 2 warnings.



Requires
--------
tcmu-runner (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_3.3.1)(64bit)
    libgfapi.so.0()(64bit)
    libgfapi.so.0(GFAPI_3.4.0)(64bit)
    libgfapi.so.0(GFAPI_3.5.0)(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libkmod.so.2()(64bit)
    libkmod.so.2(LIBKMOD_5)(64bit)
    libnl-3.so.200()(64bit)
    libnl-3.so.200(libnl_3)(64bit)
    libnl-genl-3.so.200()(64bit)
    libnl-genl-3.so.200(libnl_3)(64bit)
    libpthread.so.0()(64bit)
    rtld(GNU_HASH)
    targetcli



Provides
--------
tcmu-runner:
    tcmu-runner
    tcmu-runner(x86-64)



Unversioned so-files
--------------------
tcmu-runner: /usr/lib64/tcmu-runner/handler_file.so
tcmu-runner: /usr/lib64/tcmu-runner/handler_glfs.so

Source checksums
----------------
https://fedorahosted.org/released/tcmu-runner/tcmu-runner-0.9.0.tar.gz :
  CHECKSUM(SHA256) this package     : d8ab0cde1b7273355a43a4b39234da847575f855033d5b206cdfbe65979fa05e
  CHECKSUM(SHA256) upstream package : d8ab0cde1b7273355a43a4b39234da847575f855033d5b206cdfbe65979fa05e


Generated by fedora-review 0.5.3 (bcf15e3) last change: 2015-05-04
Command line :/usr/bin/fedora-review -b 1266999 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Note You need to log in before you can comment on or make changes to this bug.